<?php
/* Autor...:  */
/* Esquema.: MST_Color.xml */
/* Generado: 2024-07-06 04:27:46 */

/* Metodos de acceso a los campos de la tabla MST_Color */
abstract class BaseMST_ColorBN
{
    /* Campos de la tabla */
    private $i_IdColor;    // IdColor: ( no definido )
    private $i_IdProveedor;    // IdProveedor: ( no definido )
    private $s_Codigo;    // Codigo: ( no definido )
    private $s_Descripcion;    // Descripcion: ( no definido )
    private $s_Estado;    // Estado: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )

    /* Establece el valor del campo IdColor */
    public function setIdColor( $i_IdColor )
    {
        $this->i_IdColor = $i_IdColor;
    }

    /* Obtiene el valor del campo IdColor */
    public function getIdColor()
    {
        return $this->i_IdColor;
    }

    /* Establece el valor del campo IdProveedor */
    public function setIdProveedor( $i_IdProveedor )
    {
        $this->i_IdProveedor = $i_IdProveedor;
    }

    /* Obtiene el valor del campo IdProveedor */
    public function getIdProveedor()
    {
        return $this->i_IdProveedor;
    }

    /* Establece el valor del campo Codigo */
    public function setCodigo( $s_Codigo )
    {
        $this->s_Codigo = $s_Codigo;
    }

    /* Obtiene el valor del campo Codigo */
    public function getCodigo()
    {
        return $this->s_Codigo;
    }

    /* Establece el valor del campo Descripcion */
    public function setDescripcion( $s_Descripcion )
    {
        $this->s_Descripcion = $s_Descripcion;
    }

    /* Obtiene el valor del campo Descripcion */
    public function getDescripcion()
    {
        return $this->s_Descripcion;
    }

    /* Establece el valor del campo Estado */
    public function setEstado( $s_Estado )
    {
        $this->s_Estado = $s_Estado;
    }

    /* Obtiene el valor del campo Estado */
    public function getEstado()
    {
        return $this->s_Estado;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdColor' => $this->getIdColor(),
            'IdProveedor' => $this->getIdProveedor(),
            'Codigo' => $this->getCodigo(),
            'Descripcion' => $this->getDescripcion(),
            'Estado' => $this->getEstado(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto MST_ColorBN desde un RecordSet */
    public static function retrieveByRs( $o_MST_ColorRs )
    {
        $o_MST_ColorBN = new MST_ColorBN();
        $o_MST_ColorBN->setIdColor( ( integer ) $o_MST_ColorRs[ "IdColor" ] );
        $o_MST_ColorBN->setIdProveedor( ( integer ) $o_MST_ColorRs[ "IdProveedor" ] );
        $o_MST_ColorBN->setCodigo( $o_MST_ColorRs[ "Codigo" ] );
        $o_MST_ColorBN->setDescripcion( $o_MST_ColorRs[ "Descripcion" ] );
        $o_MST_ColorBN->setEstado( $o_MST_ColorRs[ "Estado" ] );
        $o_MST_ColorBN->setUsuarioCreacion( $o_MST_ColorRs[ "UsuarioCreacion" ] );
        $o_MST_ColorBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_MST_ColorRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_MST_ColorBN->setUsuarioModificacion( $o_MST_ColorRs[ "UsuarioModificacion" ] );
        $o_MST_ColorBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_MST_ColorRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        return $o_MST_ColorBN;
    }
}
?>